using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using O2S.Barcode4NET;

namespace BarcodeGridColumn
{
	/// <summary>
	/// Main application form.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid;
		private System.Windows.Forms.DataGridTableStyle dataGridTableStyle;
		private System.Windows.Forms.DataGridTextBoxColumn companyNameColumn;
		private System.Windows.Forms.DataGridTextBoxColumn contactNameColumn;
		private System.Windows.Forms.DataGridTextBoxColumn contactTitleColumn;
		private System.Windows.Forms.DataGridTextBoxColumn addressColumn;
		private System.Windows.Forms.DataGridTextBoxColumn cityColumn;
		private System.Windows.Forms.DataGridTextBoxColumn regionColumn;
		private System.Windows.Forms.DataGridTextBoxColumn postalCodeColumn;
		private System.Windows.Forms.DataGridTextBoxColumn countryColumn;
		private System.Windows.Forms.DataGridTextBoxColumn phoneColumn;
		private System.Windows.Forms.DataGridTextBoxColumn faxColumn;
		private System.Windows.Forms.Button btnPrintPreview;
		private System.Windows.Forms.PrintPreviewDialog printPreviewDialog;
		private System.Drawing.Printing.PrintDocument printDocument;
		private System.Windows.Forms.DataGridTextBoxColumn customerIDColumn;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// The index of the first row on current page.
		/// </summary>
		private int rowIndex;

		/// <summary>
		/// List of customers to be printed.
		/// </summary>
		private DataSet customers;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.dataGrid = new System.Windows.Forms.DataGrid();
			this.dataGridTableStyle = new System.Windows.Forms.DataGridTableStyle();
			this.companyNameColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.contactNameColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.contactTitleColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.addressColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.cityColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.regionColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.postalCodeColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.countryColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.phoneColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.faxColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			this.btnPrintPreview = new System.Windows.Forms.Button();
			this.printPreviewDialog = new System.Windows.Forms.PrintPreviewDialog();
			this.printDocument = new System.Drawing.Printing.PrintDocument();
			this.customerIDColumn = new System.Windows.Forms.DataGridTextBoxColumn();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid
			// 
			this.dataGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.dataGrid.CaptionText = "Customers";
			this.dataGrid.DataMember = "";
			this.dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid.Location = new System.Drawing.Point(0, 0);
			this.dataGrid.Name = "dataGrid";
			this.dataGrid.Size = new System.Drawing.Size(544, 284);
			this.dataGrid.TabIndex = 0;
			this.dataGrid.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
																								 this.dataGridTableStyle});
			// 
			// dataGridTableStyle
			// 
			this.dataGridTableStyle.DataGrid = this.dataGrid;
			this.dataGridTableStyle.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
																												 this.customerIDColumn,
																												 this.companyNameColumn,
																												 this.contactNameColumn,
																												 this.contactTitleColumn,
																												 this.addressColumn,
																												 this.cityColumn,
																												 this.regionColumn,
																												 this.postalCodeColumn,
																												 this.countryColumn,
																												 this.phoneColumn,
																												 this.faxColumn});
			this.dataGridTableStyle.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridTableStyle.MappingName = "Customers";
			// 
			// companyNameColumn
			// 
			this.companyNameColumn.Format = "";
			this.companyNameColumn.FormatInfo = null;
			this.companyNameColumn.HeaderText = "Company Name";
			this.companyNameColumn.MappingName = "CompanyName";
			this.companyNameColumn.Width = 200;
			// 
			// contactNameColumn
			// 
			this.contactNameColumn.Format = "";
			this.contactNameColumn.FormatInfo = null;
			this.contactNameColumn.HeaderText = "Contact Name";
			this.contactNameColumn.MappingName = "ContactName";
			this.contactNameColumn.Width = 120;
			// 
			// contactTitleColumn
			// 
			this.contactTitleColumn.Format = "";
			this.contactTitleColumn.FormatInfo = null;
			this.contactTitleColumn.HeaderText = "Contact Title";
			this.contactTitleColumn.MappingName = "ContactTitle";
			this.contactTitleColumn.Width = 120;
			// 
			// addressColumn
			// 
			this.addressColumn.Format = "";
			this.addressColumn.FormatInfo = null;
			this.addressColumn.HeaderText = "Address";
			this.addressColumn.MappingName = "Address";
			this.addressColumn.Width = 150;
			// 
			// cityColumn
			// 
			this.cityColumn.Format = "";
			this.cityColumn.FormatInfo = null;
			this.cityColumn.HeaderText = "City";
			this.cityColumn.MappingName = "City";
			this.cityColumn.Width = 75;
			// 
			// regionColumn
			// 
			this.regionColumn.Format = "";
			this.regionColumn.FormatInfo = null;
			this.regionColumn.HeaderText = "Region";
			this.regionColumn.MappingName = "Region";
			this.regionColumn.Width = 75;
			// 
			// postalCodeColumn
			// 
			this.postalCodeColumn.Format = "";
			this.postalCodeColumn.FormatInfo = null;
			this.postalCodeColumn.HeaderText = "Postal Code";
			this.postalCodeColumn.MappingName = "PostalCode";
			this.postalCodeColumn.Width = 75;
			// 
			// countryColumn
			// 
			this.countryColumn.Format = "";
			this.countryColumn.FormatInfo = null;
			this.countryColumn.HeaderText = "Country";
			this.countryColumn.MappingName = "Country";
			this.countryColumn.Width = 75;
			// 
			// phoneColumn
			// 
			this.phoneColumn.Format = "";
			this.phoneColumn.FormatInfo = null;
			this.phoneColumn.HeaderText = "Phone";
			this.phoneColumn.MappingName = "Phone";
			this.phoneColumn.Width = 75;
			// 
			// faxColumn
			// 
			this.faxColumn.Format = "";
			this.faxColumn.FormatInfo = null;
			this.faxColumn.HeaderText = "Fax";
			this.faxColumn.MappingName = "Fax";
			this.faxColumn.Width = 75;
			// 
			// btnPrintPreview
			// 
			this.btnPrintPreview.Location = new System.Drawing.Point(424, 288);
			this.btnPrintPreview.Name = "btnPrintPreview";
			this.btnPrintPreview.Size = new System.Drawing.Size(116, 23);
			this.btnPrintPreview.TabIndex = 1;
			this.btnPrintPreview.Text = "Print preview";
			this.btnPrintPreview.Click += new System.EventHandler(this.btnPrintPreview_Click);
			// 
			// printPreviewDialog
			// 
			this.printPreviewDialog.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.printPreviewDialog.ClientSize = new System.Drawing.Size(400, 300);
			this.printPreviewDialog.Document = this.printDocument;
			this.printPreviewDialog.Enabled = true;
			this.printPreviewDialog.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialog.Icon")));
			this.printPreviewDialog.Location = new System.Drawing.Point(198, 137);
			this.printPreviewDialog.MinimumSize = new System.Drawing.Size(375, 250);
			this.printPreviewDialog.Name = "printPreviewDialog";
			this.printPreviewDialog.TransparencyKey = System.Drawing.Color.Empty;
			this.printPreviewDialog.Visible = false;
			// 
			// printDocument
			// 
			this.printDocument.BeginPrint += new System.Drawing.Printing.PrintEventHandler(this.printDocument_BeginPrint);
			this.printDocument.QueryPageSettings += new System.Drawing.Printing.QueryPageSettingsEventHandler(this.printDocument_QueryPageSettings);
			this.printDocument.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocument_PrintPage);
			// 
			// customerIDColumn
			// 
			this.customerIDColumn.Format = "";
			this.customerIDColumn.FormatInfo = null;
			this.customerIDColumn.HeaderText = "Customer ID";
			this.customerIDColumn.MappingName = "CustomerID";
			this.customerIDColumn.Width = 70;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(544, 313);
			this.Controls.Add(this.btnPrintPreview);
			this.Controls.Add(this.dataGrid);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.Text = "Barcode4NET - Barcode Print demo";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Load the customers dataset.
			customers = new DataSet( );
			// The path is relative to the exe file.
			customers.ReadXml("..\\..\\Samples\\Windows Forms\\BarcodePrint\\CS\\Net 2.0\\customers.net20.xml", XmlReadMode.ReadSchema);
			customers.Tables[0].TableName = "Customers";

			// Bind the data to the grid.
			dataGrid.DataSource = customers.Tables[0];
		}

		private void btnPrintPreview_Click(object sender, System.EventArgs e)
		{
			printPreviewDialog.ShowDialog( );
		}

		private void printDocument_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			float leftMargin = e.MarginBounds.Left;
			float topMargin = e.MarginBounds.Top;
			float topPosition = 0;

			SolidBrush blackBrush = new SolidBrush( Color.Black );
			Font fontTitle = new Font( "Tahoma", 8, FontStyle.Bold, GraphicsUnit.Point );
			Font fontText = new Font( "Tahoma", 8, GraphicsUnit.Point );
			float fontHeight = fontText.GetHeight( e.Graphics );
			float sectionHeight = fontHeight * 6;
			float leftTextOffset = 160;

			// Use a Code 39 barcode.
			Code39Barcode barcode = new Code39Barcode( );
			barcode.DimensionUnit = XYDimensionUnit.Inch;
			barcode.XDimension = 1/72f;
			barcode.YDimension = 0.5f;
			barcode.DataDisplayLocation = BarcodeTextLocation.BelowEmbedded;

			while( true )
			{
				// If a full customer section does not fit on the page, go to next page.
				if( topPosition + sectionHeight > e.MarginBounds.Height )
				{
					break;
				}
				// If there are no more rows, exit.
				if( rowIndex >= customers.Tables[0].Rows.Count )
				{
					break;
				}

				// Get the data from current row.
				string customerID = customers.Tables[0].Rows[rowIndex]["CustomerID"].ToString( );
				string companyName = customers.Tables[0].Rows[rowIndex]["CompanyName"].ToString( );
				string contactName = customers.Tables[0].Rows[rowIndex]["ContactName"].ToString( );
				string contactTitle = customers.Tables[0].Rows[rowIndex]["ContactTitle"].ToString( );
				string address = customers.Tables[0].Rows[rowIndex]["Address"].ToString( );
				string city = customers.Tables[0].Rows[rowIndex]["City"].ToString( );
				string postalCode = customers.Tables[0].Rows[rowIndex]["PostalCode"].ToString( );
				string country = customers.Tables[0].Rows[rowIndex]["Country"].ToString( );
				string phone = customers.Tables[0].Rows[rowIndex]["Phone"].ToString( );
				string fax = customers.Tables[0].Rows[rowIndex]["Fax"].ToString( );

				// Draw the barcode.
				barcode.Data = customerID;
				Bitmap barcodeImage = barcode.GetImage( e.Graphics.DpiX, e.Graphics.DpiY );
				e.Graphics.DrawImageUnscaled( barcodeImage, ( int )leftMargin, ( int )( topMargin + topPosition ) );
				barcodeImage.Dispose( );

				// Draw the text.
				e.Graphics.DrawString( companyName, fontTitle, blackBrush, 
					leftMargin + leftTextOffset, topMargin + topPosition );
				e.Graphics.DrawString( contactName + " - " + contactTitle, fontText, blackBrush, 
					leftMargin + leftTextOffset, topMargin + topPosition + fontHeight );
				e.Graphics.DrawString( address, fontText, blackBrush, 
					leftMargin + leftTextOffset, topMargin + topPosition + 2*fontHeight );
				e.Graphics.DrawString( city + ", " + postalCode + ", " + country, fontText, blackBrush, 
					leftMargin + leftTextOffset, topMargin + topPosition + 3*fontHeight );
				e.Graphics.DrawString( phone + " / " + fax, fontText, blackBrush, 
					leftMargin + leftTextOffset, topMargin + topPosition + 4*fontHeight );

				// Go to next row.
				rowIndex++;
				topPosition = topPosition + sectionHeight;
			}

			// There are more pages if last row has not been reached.
			e.HasMorePages = rowIndex < customers.Tables[0].Rows.Count;
		}

		private void printDocument_BeginPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
		{
			// Start printing with first row.
			rowIndex = 0;
		}

		private void printDocument_QueryPageSettings(object sender, System.Drawing.Printing.QueryPageSettingsEventArgs e)
		{
			e.PageSettings.Margins.Left = 50;
			e.PageSettings.Margins.Top = 50;
			e.PageSettings.Margins.Right = 50;
			e.PageSettings.Margins.Bottom = 50;
		}
	}
}
